package cn.vscoder.experiment_5.Sport_Register;

import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.border.*;
/*
 * Created by JFormDesigner on Mon May 12 16:02:01 CST 2025
 */


/**
 * @author xulongjin
 */
public class SportRegister extends JFrame {
    public SportRegister() {
        initComponents();
    }

    private void selectSexBoyItemStateChanged(ItemEvent e) {
        // TODO add your code here
        selectCompetitiveItem.removeAllItems();
        outputMessage.setText("");
        items.clear();
        selectCompetitiveItem.addItem("参赛项");
        selectCompetitiveItem.addItem("男子跳高");
        selectCompetitiveItem.addItem("男子跳远");
        selectCompetitiveItem.addItem("男子铅球");
        selectCompetitiveItem.addItem("男子100米");
        selectCompetitiveItem.addItem("男子400米");
        selectCompetitiveItem.addItem("男子自由泳");
    }

    private void selectSexGirlItemStateChanged(ItemEvent e) {
        // TODO add your code here
        selectCompetitiveItem.removeAllItems();
        outputMessage.setText("");
        items.clear();
        selectCompetitiveItem.addItem("参赛项");
        selectCompetitiveItem.addItem("女子跳高");
        selectCompetitiveItem.addItem("女子跳远");
        selectCompetitiveItem.addItem("女子铅球");
        selectCompetitiveItem.addItem("女子100米");
        selectCompetitiveItem.addItem("女子400米");
        selectCompetitiveItem.addItem("女子自由泳");
    }

    private void bottomReset(ActionEvent e) {
        // TODO add your code here
        inputName.setText("");
        inputSn.setText("");
        selectSexBoy.setSelected(true);
        outputMessage.setText("");
        items.clear();
    }

    private void bottomPush(ActionEvent e) {
        // TODO add your code here
        if (inputName.getText().isEmpty() || inputSn.getText().isEmpty() || items.isEmpty()) {
            JOptionPane.showMessageDialog(
                    this,
                    "信息不完整，请填写完整",
                    "提示",
                    JOptionPane.ERROR_MESSAGE
            );
        } else {
            outputMessage.append("\n---------------------\n");
            outputMessage.append("姓名:" + inputName.getText() + ",学号:" + inputSn.getText() + ",\n报名项目:");
            for (int i = 0; i < items.size(); i++) {
                outputMessage.append(items.get(i));
                if (!(i == items.size() - 1)){
                    outputMessage.append("、");
                }
            }
            outputMessage.append("\n--------报名成功-------");
        }

    }

    private void selectCompetitiveItem(ActionEvent e) {
        // TODO add your code here
        String selectedItem = (String) selectCompetitiveItem.getSelectedItem();
        if (selectedItem != null && !selectedItem.trim().isEmpty() && !selectedItem.equals("参赛项")) {
            String item = outputMessage.getText();
            if (!item.contains(selectedItem + ";")) {
                outputMessage.append(selectedItem + ";");
                items.add(selectedItem);
            }
        }
    }

    private void initComponents() {
        // JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents  @formatter:off
        panel1 = new JPanel();
        textName = new JLabel();
        textSn = new JLabel();
        inputName = new JTextField();
        inputSn = new JTextField();
        panel2 = new JPanel();
        selectSexBoy = new JRadioButton();
        selectSexGirl = new JRadioButton();
        panel3 = new JPanel();
        selectCompetitiveItem = new JComboBox<>();
        scrollPane1 = new JScrollPane();
        outputMessage = new JTextArea();
        panel4 = new JPanel();
        bottomReset = new JButton();
        bottomPush = new JButton();

        //======== this ========
        var contentPane = getContentPane();
        contentPane.setLayout(new GridLayout(5, 0));

        //======== panel1 ========
        {
            panel1.setBorder(new TitledBorder("\u57fa\u7840\u4fe1\u606f"));
            panel1.setLayout(null);

            //---- textName ----
            textName.setText("\u59d3\u540d\uff1a");
            panel1.add(textName);
            textName.setBounds(25, 32, 40, 34);

            //---- textSn ----
            textSn.setText("\u5b66\u53f7\uff1a");
            panel1.add(textSn);
            textSn.setBounds(205, 30, 40, 34);
            panel1.add(inputName);
            inputName.setBounds(65, 30, 125, 35);
            panel1.add(inputSn);
            inputSn.setBounds(250, 30, 125, 35);

            {
                // compute preferred size
                Dimension preferredSize = new Dimension();
                for(int i = 0; i < panel1.getComponentCount(); i++) {
                    Rectangle bounds = panel1.getComponent(i).getBounds();
                    preferredSize.width = Math.max(bounds.x + bounds.width, preferredSize.width);
                    preferredSize.height = Math.max(bounds.y + bounds.height, preferredSize.height);
                }
                Insets insets = panel1.getInsets();
                preferredSize.width += insets.right;
                preferredSize.height += insets.bottom;
                panel1.setMinimumSize(preferredSize);
                panel1.setPreferredSize(preferredSize);
            }
        }
        contentPane.add(panel1);

        //======== panel2 ========
        {
            panel2.setBorder(new TitledBorder("\u9009\u62e9\u6027\u522b"));
            panel2.setLayout(null);

            //---- selectSexBoy ----
            selectSexBoy.setText("\u7537");
            selectSexBoy.setSelected(true);
            selectSexBoy.addItemListener(e -> selectSexBoyItemStateChanged(e));
            panel2.add(selectSexBoy);
            selectSexBoy.setBounds(115, 35, 55, 30);

            //---- selectSexGirl ----
            selectSexGirl.setText("\u5973");
            selectSexGirl.addItemListener(e -> selectSexGirlItemStateChanged(e));
            panel2.add(selectSexGirl);
            selectSexGirl.setBounds(205, 35, 55, 30);

            {
                // compute preferred size
                Dimension preferredSize = new Dimension();
                for(int i = 0; i < panel2.getComponentCount(); i++) {
                    Rectangle bounds = panel2.getComponent(i).getBounds();
                    preferredSize.width = Math.max(bounds.x + bounds.width, preferredSize.width);
                    preferredSize.height = Math.max(bounds.y + bounds.height, preferredSize.height);
                }
                Insets insets = panel2.getInsets();
                preferredSize.width += insets.right;
                preferredSize.height += insets.bottom;
                panel2.setMinimumSize(preferredSize);
                panel2.setPreferredSize(preferredSize);
            }
        }
        contentPane.add(panel2);

        //======== panel3 ========
        {
            panel3.setBorder(new TitledBorder("\u9009\u62e9\u53c2\u8d5b\u9879\u76ee"));
            panel3.setLayout(null);

            //---- selectCompetitiveItem ----
            selectCompetitiveItem.setModel(new DefaultComboBoxModel<>(new String[] {
                "\u53c2\u8d5b\u9879"
            }));
            selectCompetitiveItem.addActionListener(e -> selectCompetitiveItem(e));
            panel3.add(selectCompetitiveItem);
            selectCompetitiveItem.setBounds(115, 35, 140, 40);

            {
                // compute preferred size
                Dimension preferredSize = new Dimension();
                for(int i = 0; i < panel3.getComponentCount(); i++) {
                    Rectangle bounds = panel3.getComponent(i).getBounds();
                    preferredSize.width = Math.max(bounds.x + bounds.width, preferredSize.width);
                    preferredSize.height = Math.max(bounds.y + bounds.height, preferredSize.height);
                }
                Insets insets = panel3.getInsets();
                preferredSize.width += insets.right;
                preferredSize.height += insets.bottom;
                panel3.setMinimumSize(preferredSize);
                panel3.setPreferredSize(preferredSize);
            }
        }
        contentPane.add(panel3);

        //======== scrollPane1 ========
        {
            scrollPane1.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
            scrollPane1.setBorder(new TitledBorder("\u62a5\u540d\u4fe1\u606f"));
            scrollPane1.setViewportView(outputMessage);
        }
        contentPane.add(scrollPane1);

        //======== panel4 ========
        {
            panel4.setBorder(new TitledBorder("\u64cd\u4f5c"));
            panel4.setLayout(null);

            //---- bottomReset ----
            bottomReset.setText("\u91cd\u7f6e");
            bottomReset.addActionListener(e -> bottomReset(e));
            panel4.add(bottomReset);
            bottomReset.setBounds(new Rectangle(new Point(95, 40), bottomReset.getPreferredSize()));

            //---- bottomPush ----
            bottomPush.setText("\u63d0\u4ea4");
            bottomPush.addActionListener(e -> bottomPush(e));
            panel4.add(bottomPush);
            bottomPush.setBounds(210, 40, 78, 34);

            {
                // compute preferred size
                Dimension preferredSize = new Dimension();
                for(int i = 0; i < panel4.getComponentCount(); i++) {
                    Rectangle bounds = panel4.getComponent(i).getBounds();
                    preferredSize.width = Math.max(bounds.x + bounds.width, preferredSize.width);
                    preferredSize.height = Math.max(bounds.y + bounds.height, preferredSize.height);
                }
                Insets insets = panel4.getInsets();
                preferredSize.width += insets.right;
                preferredSize.height += insets.bottom;
                panel4.setMinimumSize(preferredSize);
                panel4.setPreferredSize(preferredSize);
            }
        }
        contentPane.add(panel4);
        pack();
        setLocationRelativeTo(getOwner());
        // JFormDesigner - End of component initialization  //GEN-END:initComponents  @formatter:on
        selectSexBoyItemStateChanged(null);
        ButtonGroup buttonGroup = new ButtonGroup();
        buttonGroup.add(selectSexGirl);
        buttonGroup.add(selectSexBoy);
    }

    // JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables  @formatter:off
    private JPanel panel1;
    private JLabel textName;
    private JLabel textSn;
    private JTextField inputName;
    private JTextField inputSn;
    private JPanel panel2;
    private JRadioButton selectSexBoy;
    private JRadioButton selectSexGirl;
    private JPanel panel3;
    private JComboBox<String> selectCompetitiveItem;
    private JScrollPane scrollPane1;
    private JTextArea outputMessage;
    private JPanel panel4;
    private JButton bottomReset;
    private JButton bottomPush;
    // JFormDesigner - End of variables declaration  //GEN-END:variables  @formatter:on

    ArrayList<String> items = new ArrayList<>();
}
